#include <cstring>
#include <iostream>

#include <netplus/exception.h>
#include <netplus/socket.h>

#include <httppp/http.h>
#include <httppp/httpd.h>
#include <httppp/exception.h>

#include <unistd.h>

#include <config.h>

class AdminController : public netplus::event  {
public:
    AdminController(netplus::socket *serversocket) : event(serversocket) {

    };

    void RequestEvent(netplus::con *curcon){
        libhttppp::HttpRequest http;
        try{
            http.parse(curcon);
            std::cout << http.getRequestURL() << std::endl;
            libhttppp::HttpResponse resp;
            resp.setState(HTTP200);
            resp.setContentType("text/html");
            resp.send(curcon,http.getRequestURL(),strlen(http.getRequestURL()));
        }catch(libhttppp::HTTPException &e){
            std::cerr << e.what() << std::endl;
        }
    };
};

class  AdminHttpD : public libhttppp::HttpD {
public:
    AdminHttpD(const char *httpaddr, int port,int maxconnections,const char *sslcertpath,const char *sslkeypath)
            : HttpD(httpaddr,port,maxconnections,sslcertpath,sslkeypath){
        libhttppp::HTTPException httpexception;
        try {
            AdminController admctl(getServerSocket());
            admctl.runEventloop();
        }catch(netplus::NetException &e){
            std::cout << e.what() << std::endl;
        }
    };
};

int main(int argc,char *argv[]){
    try{

        if(access(ADMINCTL_BIND_DIR(adm.sock),F_OK)==0){
            unlink(ADMINCTL_BIND_DIR(adm.sock));
        }

        AdminHttpD admd(ADMINCTL_BIND_DIR(adm.sock),-1,1024,nullptr,nullptr);
    }catch(libhttppp::HTTPException &e){
        std::cerr << e.what() << std::endl;
    }
}
